package com.something.test;

import java.util.Set;

import org.jboss.cache.Cache;
import org.jboss.cache.CacheFactory;
import org.jboss.cache.DefaultCacheFactory;
import org.jboss.cache.Fqn;
import org.jboss.cache.Node;
import org.jboss.system.ServiceMBeanSupport;

public class Test extends ServiceMBeanSupport implements TestMBean
{

	@Override
	public String hello() {
		// TODO Auto-generated method stub
		return null;
	}
	
	private Cache<String, String> cache;
	
	@Override
	public void startService()
	{
		CacheFactory<String, String> factory = new DefaultCacheFactory<String, String>();
		cache = factory.createCache("replSync-service.xml");
		
		System.out.println("Calling cache.start...");
		cache.start();
		
		System.out.println("Calling cache.getRoot...");
		Node<String, String> rootNode = cache.getRoot();
		System.out.println("getRoot returned: " + rootNode);
		
		Fqn<String> fqn = Fqn.fromElements("blap");
		System.out.println("Calling addChild...");
		
		try
		{
			Node<String, String> child = rootNode.addChild(fqn);
			System.out.println("Child added: " + child);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		
		System.out.println("Calling rootNode.getChildrenNames...");
		try
		{
			Set<Object> names = rootNode.getChildrenNames();
			System.out.println("getChildrenNames returned: ");
			for(Object name : names)
			{
				System.out.println("    " + name);
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	public void stopService()
	{
		cache.stop();
	}

}
